/* base/stringperror.H: part of meabench, an MEA recording and analysis tool
** Copyright (C) 2000-2002  Daniel Wagenaar (wagenaar@caltech.edu)
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// stringperror.H

#ifndef STRINGPERROR_H

#define STRINGPERROR_H

#include <string>

using namespace std;

string stringperror(string prefix); //:F stringperror
/*:D s=stringperror(prefix) returns a string composed of the given prefix,
     followed by the error message read from strerror. Thus it does perror's
     job except that output is stored in a string rather than sent to stderr.
 *:A prefix: text to output before the system error message.
 *:R perror(3) style composite error message.
 */

#endif
